diff --git a/gcc/diagnostic.c b/gcc/diagnostic.c
index acc44b1..0083eda 100644
--- a/gcc/diagnostic.c
+++ b/gcc/diagnostic.c
@@ -1651,7 +1644,7 @@ assert_location_text (const char *expected_loc_text,
 		      bool show_column)
 {
   test_diagnostic_context dc;
-  dc.show_column = show_column;
+  dc.m_show_column = show_column;
 
   expanded_location xloc;
   xloc.file = filename;
diff --git a/gcc/diagnostic.h b/gcc/diagnostic.h
index bdcbc62..0e57d2b 100644
--- a/gcc/diagnostic.h
+++ b/gcc/diagnostic.h
@@ -66,20 +66,67 @@ class edit_context;
 
 /* This data structure bundles altogether any information relevant to
    the context of a diagnostic message.  */
-struct diagnostic_context
+class diagnostic_context
 {
+public:
+  void initialize (int);
+  void color_init (int value = -1);
+  void finish ();
+
+  bool report_diagnostic (diagnostic_info *);
+  void report_current_module (location_t);
+
+  /* Force diagnostics controlled by OPTIDX to be kind KIND.  */
+  diagnostic_t classify_diagnostic (int /* optidx */,
+				    diagnostic_t /* kind */,
+				    location_t);
+  void push_diagnostics (location_t);
+  void pop_diagnostics (location_t);
+
+  void inhibit_notes () { m_inhibit_notes_p = true; }
+
+  /* The total count of a KIND of diagnostics emitted so far.  */
+  int& kind_count (diagnostic_t kind) { return m_diagnostic_count[kind]; }
+
+  void action_after_output (diagnostic_t);
+
+  void set_caret_char (int idx, char ch)
+  {
+    gcc_assert (idx < rich_location::STATICALLY_ALLOCATED_RANGES);
+    m_caret_chars[idx] = ch;
+  }
+  char get_caret_char (int idx) const
+  {
+    gcc_assert (idx < rich_location::STATICALLY_ALLOCATED_RANGES);
+    return m_caret_chars[idx];
+  }
+
+ private:
+  void error_recursion () ATTRIBUTE_NORETURN;
+  diagnostic_t update_effective_level_from_pragmas (diagnostic_info *) const;
+
+  bool last_module_changed_p (const line_map_ordinary *map);
+  void set_last_module (const line_map_ordinary *map);
+
+  //private:
+ public:
   /* Where most of the diagnostic formatting work is done.  */
-  pretty_printer *printer;
+  pretty_printer *m_printer;
 
+ private:
   /* The number of times we have issued diagnostics.  */
-  int diagnostic_count[DK_LAST_DIAGNOSTIC_KIND];
+  int m_diagnostic_count[DK_LAST_DIAGNOSTIC_KIND];
 
+ public:
   /* True if it has been requested that warnings be treated as errors.  */
-  bool warning_as_error_requested;
+  bool m_warning_as_error_requested;
 
+ private:
   /* The number of option indexes that can be passed to warning() et
      al.  */
-  int n_opts;
+  int m_n_opts;
+
+ public: // FIXME: read from in a couple of places:
 
   /* For each option index that can be passed to warning() et al
      (OPT_* from options.h when using this code with the core GCC
@@ -87,63 +134,69 @@ struct diagnostic_context
      should be changed to before reporting, or DK_UNSPECIFIED to leave
      it as the reported kind, or DK_IGNORED to not report it at
      all.  */
-  diagnostic_t *classify_diagnostic;
+  diagnostic_t *m_classify_diagnostic;
 
+ private:
   /* History of all changes to the classifications above.  This list
      is stored in location-order, so we can search it, either
      binary-wise or end-to-front, to find the most recent
      classification for a given diagnostic, given the location of the
      diagnostic.  */
-  diagnostic_classification_change_t *classification_history;
+  diagnostic_classification_change_t *m_classification_history;
 
   /* The size of the above array.  */
-  int n_classification_history;
+  int m_n_classification_history;
 
   /* For pragma push/pop.  */
-  int *push_list;
-  int n_push;
+  int *m_push_list;
+  int m_n_push;
+
+ public: // FIXME: modified in a few places
 
   /* True if we should print the source line with a caret indicating
      the location.  */
-  bool show_caret;
+  bool m_show_caret;
 
+ public:
   /* Maximum width of the source line printed.  */
-  int caret_max_width;
+  int m_caret_max_width;
 
+ private:
   /* Character used for caret diagnostics.  */
-  char caret_chars[rich_location::STATICALLY_ALLOCATED_RANGES];
+  char m_caret_chars[rich_location::STATICALLY_ALLOCATED_RANGES];
 
+ public:
   /* True if we should print the command line option which controls
      each diagnostic, if known.  */
-  bool show_option_requested;
+  bool m_show_option_requested;
 
   /* True if we should raise a SIGABRT on errors.  */
-  bool abort_on_error;
+  bool m_abort_on_error;
 
   /* True if we should show the column number on diagnostics.  */
-  bool show_column;
+  bool m_show_column;
 
   /* True if pedwarns are errors.  */
-  bool pedantic_errors;
+  bool m_pedantic_errors;
 
   /* True if permerrors are warnings.  */
-  bool permissive;
+  bool m_permissive;
 
   /* The index of the option to associate with turning permerrors into
      warnings.  */
-  int opt_permissive;
+  int m_opt_permissive;
 
   /* True if errors are fatal.  */
-  bool fatal_errors;
+  bool m_fatal_errors;
 
   /* True if all warnings should be disabled.  */
-  bool dc_inhibit_warnings;
+  bool m_inhibit_warnings;
 
   /* True if warnings should be given in system headers.  */
-  bool dc_warn_system_headers;
+  bool m_warn_system_headers;
 
   /* Maximum number of errors to report.  */
-  int max_errors;
+  int m_max_errors;
 
   /* This function is called before any message is printed out.  It is
      responsible for preparing message prefix and such.  For example, it
@@ -152,26 +205,26 @@ struct diagnostic_context
                       from "/home/gdr/src/nifty_printer.h:56:
                       ...
   */
-  diagnostic_starter_fn begin_diagnostic;
+  diagnostic_starter_fn m_begin_diagnostic;
 
   /* This function is called by diagnostic_show_locus in between
      disjoint spans of source code, so that the context can print
      something to indicate that a new span of source code has begun.  */
-  diagnostic_start_span_fn start_span;
+  diagnostic_start_span_fn m_start_span;
 
   /* This function is called after the diagnostic message is printed.  */
-  diagnostic_finalizer_fn end_diagnostic;
+  diagnostic_finalizer_fn m_end_diagnostic;
 
   /* Client hook to report an internal error.  */
-  void (*internal_error) (diagnostic_context *, const char *, va_list *);
+  void (*m_internal_error) (diagnostic_context *, const char *, va_list *);
 
   /* Client hook to say whether the option controlling a diagnostic is
      enabled.  Returns nonzero if enabled, zero if disabled.  */
-  int (*option_enabled) (int, void *);
+  int (*m_option_enabled) (int, void *);
 
   /* Client information to pass as second argument to
      option_enabled.  */
-  void *option_state;
+  void *m_option_state;
 
   /* Client hook to return the name of an option that controls a
      diagnostic.  Returns malloced memory.  The first diagnostic_t
@@ -179,21 +232,24 @@ struct diagnostic_context
      (of warnings as errors, etc.); the second is the kind after any
      reclassification.  May return NULL if no name is to be printed.
      May be passed 0 as well as the index of a particular option.  */
-  char *(*option_name) (diagnostic_context *, int, diagnostic_t, diagnostic_t);
+  char *(*m_option_name) (diagnostic_context *, int, diagnostic_t, diagnostic_t);
 
   /* Auxiliary data for client.  */
-  void *x_data;
+  void *m_x_data;
 
+  //private:
   /* Used to detect that the last caret was printed at the same location.  */
-  location_t last_location;
+  location_t m_last_location;
 
   /* Used to detect when the input file stack has changed since last
      described.  */
-  const line_map_ordinary *last_module;
+  const line_map_ordinary *m_last_module;
 
-  int lock;
+ private:
+  int m_lock;
 
-  bool inhibit_notes_p;
+ public:
+  bool m_inhibit_notes_p;
 
   /* When printing source code, should the characters at carets and ranges
      be colorized? (assuming colorization is on at all).
@@ -202,74 +258,64 @@ struct diagnostic_context
      and false for frontends that merely specify points within the
      source code (to avoid e.g. colorizing just the first character in
      a token, which would look strange).  */
-  bool colorize_source_p;
+  bool m_colorize_source_p;
 
   /* Usable by plugins; if true, print a debugging ruler above the
      source output.  */
-  bool show_ruler_p;
+  bool m_show_ruler_p;
 
   /* If true, print fixits in machine-parseable form after the
      rest of the diagnostic.  */
-  bool parseable_fixits_p;
+  bool m_parseable_fixits_p;
 
   /* If non-NULL, an edit_context to which fix-it hints should be
      applied, for generating patches.  */
-  edit_context *edit_context_ptr;
+  edit_context *m_edit_context_ptr;
 
   /* FIXME.  */
-  source_manager *src_manager;
+  source_manager *m_src_manager;
 };
 
-static inline void
-diagnostic_inhibit_notes (diagnostic_context * context)
-{
-  context->inhibit_notes_p = true;
-}
-
-
 /* Client supplied function to announce a diagnostic.  */
-#define diagnostic_starter(DC) (DC)->begin_diagnostic
+#define diagnostic_starter(DC) (DC)->m_begin_diagnostic
 
 /* Client supplied function called after a diagnostic message is
    displayed.  */
-#define diagnostic_finalizer(DC) (DC)->end_diagnostic
+#define diagnostic_finalizer(DC) (DC)->m_end_diagnostic
 
 /* Extension hooks for client.  */
-#define diagnostic_context_auxiliary_data(DC) (DC)->x_data
+#define diagnostic_context_auxiliary_data(DC) (DC)->m_x_data
 #define diagnostic_info_auxiliary_data(DI) (DI)->x_data
 
 /* Same as pp_format_decoder.  Works on 'diagnostic_context *'.  */
-#define diagnostic_format_decoder(DC) ((DC)->printer->format_decoder)
+#define diagnostic_format_decoder(DC) ((DC)->m_printer->format_decoder)
 
 /* Same as output_prefixing_rule.  Works on 'diagnostic_context *'.  */
-#define diagnostic_prefixing_rule(DC) ((DC)->printer->wrapping.rule)
+#define diagnostic_prefixing_rule(DC) ((DC)->m_printer->wrapping.rule)
 
 /* Raise SIGABRT on any diagnostic of severity DK_ERROR or higher.  */
 #define diagnostic_abort_on_error(DC) \
-  (DC)->abort_on_error = true
+  (DC)->m_abort_on_error = true
 
 /* This diagnostic_context is used by front-ends that directly output
    diagnostic messages without going through `error', `warning',
    and similar functions.  */
 extern diagnostic_context *global_dc;
 
-/* The total count of a KIND of diagnostics emitted so far.  */
-#define diagnostic_kind_count(DC, DK) (DC)->diagnostic_count[(int) (DK)]
-
 /* The number of errors that have been issued so far.  Ideally, these
    would take a diagnostic_context as an argument.  */
-#define errorcount diagnostic_kind_count (global_dc, DK_ERROR)
+#define errorcount global_dc->kind_count (DK_ERROR)
 /* Similarly, but for warnings.  */
-#define warningcount diagnostic_kind_count (global_dc, DK_WARNING)
+#define warningcount global_dc->kind_count (DK_WARNING)
 /* Similarly, but for warnings promoted to errors.  */
-#define werrorcount diagnostic_kind_count (global_dc, DK_WERROR)
+#define werrorcount global_dc->kind_count (DK_WERROR)
 /* Similarly, but for sorrys.  */
-#define sorrycount diagnostic_kind_count (global_dc, DK_SORRY)
+#define sorrycount global_dc->kind_count (DK_SORRY)
 
 /* Returns nonzero if warnings should be emitted.  */
 #define diagnostic_report_warnings_p(DC, LOC)				\
-  (!(DC)->dc_inhibit_warnings						\
-   && !(in_system_header_at (LOC) && !(DC)->dc_warn_system_headers))
+  (!(DC)->m_inhibit_warnings						\
+   && !(in_system_header_at (LOC) && !(DC)->m_warn_system_headers))
 
 /* Override the option index to be used for reporting a
    diagnostic.  */
@@ -281,23 +327,10 @@ diagnostic_override_option_index (diagnostic_info *info, int optidx)
 }
 
 /* Diagnostic related functions.  */
-extern void diagnostic_initialize (diagnostic_context *, int);
-extern void diagnostic_color_init (diagnostic_context *, int value = -1);
-extern void diagnostic_finish (diagnostic_context *);
-extern void diagnostic_report_current_module (diagnostic_context *, location_t);
 extern void diagnostic_show_locus (diagnostic_context *,
 				   rich_location *richloc,
 				   diagnostic_t diagnostic_kind);
 
-/* Force diagnostics controlled by OPTIDX to be kind KIND.  */
-extern diagnostic_t diagnostic_classify_diagnostic (diagnostic_context *,
-						    int /* optidx */,
-						    diagnostic_t /* kind */,
-						    location_t);
-extern void diagnostic_push_diagnostics (diagnostic_context *, location_t);
-extern void diagnostic_pop_diagnostics (diagnostic_context *, location_t);
-extern bool diagnostic_report_diagnostic (diagnostic_context *,
-					  diagnostic_info *);
 #ifdef ATTRIBUTE_GCC_DIAG
 extern void diagnostic_set_info (diagnostic_info *, const char *, va_list *,
 				 rich_location *, diagnostic_t) ATTRIBUTE_GCC_DIAG(2,0);
@@ -314,7 +347,6 @@ void default_diagnostic_start_span_fn (diagnostic_context *,
 				       expanded_location);
 void default_diagnostic_finalizer (diagnostic_context *, diagnostic_info *);
 void diagnostic_set_caret_max_width (diagnostic_context *context, int value);
-void diagnostic_action_after_output (diagnostic_context *, diagnostic_t);
 void diagnostic_check_max_errors (diagnostic_context *, bool flush = false);
 
 void diagnostic_file_cache_fini (void);
@@ -362,7 +394,7 @@ diagnostic_same_line (const diagnostic_context *context,
 		       expanded_location s1, expanded_location s2)
 {
   return s2.column && s1.line == s2.line 
-    && context->caret_max_width - CARET_LINE_MARGIN > abs (s1.column - s2.column);
+    && context->m_caret_max_width - CARET_LINE_MARGIN > abs (s1.column - s2.column);
 }
 
 extern const char *diagnostic_get_color_for_kind (diagnostic_t kind);
diff --git a/gcc/fortran/cpp.c b/gcc/fortran/cpp.c
index 82e890f..c99d6b0 100644
--- a/gcc/fortran/cpp.c
+++ b/gcc/fortran/cpp.c
@@ -1029,13 +1029,13 @@ cb_cpp_error (cpp_reader *pfile ATTRIBUTE_UNUSED, int level, int reason,
 {
   diagnostic_info diagnostic;
   diagnostic_t dlevel;
-  bool save_warn_system_headers = global_dc->dc_warn_system_headers;
+  bool save_warn_system_headers = global_dc->m_warn_system_headers;
   bool ret;
 
   switch (level)
     {
     case CPP_DL_WARNING_SYSHDR:
-      global_dc->dc_warn_system_headers = 1;
+      global_dc->m_warn_system_headers = 1;
       /* Fall through.  */
     case CPP_DL_WARNING:
       dlevel = DK_WARNING;
@@ -1062,9 +1062,9 @@ cb_cpp_error (cpp_reader *pfile ATTRIBUTE_UNUSED, int level, int reason,
 				  richloc, dlevel);
   if (reason == CPP_W_WARNING_DIRECTIVE)
     diagnostic_override_option_index (&diagnostic, OPT_Wcpp);
-  ret = diagnostic_report_diagnostic (global_dc, &diagnostic);
+  ret = global_dc->report_diagnostic (&diagnostic);
   if (level == CPP_DL_WARNING_SYSHDR)
-    global_dc->dc_warn_system_headers = save_warn_system_headers;
+    global_dc->m_warn_system_headers = save_warn_system_headers;
   return ret;
 }
 
diff --git a/gcc/fortran/error.c b/gcc/fortran/error.c
index cf9e57b..17e2df0 100644
--- a/gcc/fortran/error.c
+++ b/gcc/fortran/error.c
@@ -750,14 +750,14 @@ error_printf (const char *gmsgid, ...)
 static void
 gfc_clear_pp_buffer (output_buffer *this_buffer)
 {
-  pretty_printer *pp = global_dc->printer;
+  pretty_printer *pp = global_dc->m_printer;
   output_buffer *tmp_buffer = pp->buffer;
   pp->buffer = this_buffer;
   pp_clear_output_area (pp);
   pp->buffer = tmp_buffer;
   /* We need to reset last_location, otherwise we may skip caret lines
      when we actually give a diagnostic.  */
-  global_dc->last_location = UNKNOWN_LOCATION;
+  global_dc->m_last_location = UNKNOWN_LOCATION;
 }
 
 
@@ -772,8 +772,8 @@ gfc_warning (int opt, const char *gmsgid, va_list ap)
 
   diagnostic_info diagnostic;
   rich_location rich_loc (line_table, UNKNOWN_LOCATION);
-  bool fatal_errors = global_dc->fatal_errors;
-  pretty_printer *pp = global_dc->printer;
+  bool fatal_errors = global_dc->m_fatal_errors;
+  pretty_printer *pp = global_dc->m_printer;
   output_buffer *tmp_buffer = pp->buffer;
 
   gfc_clear_pp_buffer (pp_warning_buffer);
@@ -781,7 +781,7 @@ gfc_warning (int opt, const char *gmsgid, va_list ap)
   if (buffered_p)
     {
       pp->buffer = pp_warning_buffer;
-      global_dc->fatal_errors = false;
+      global_dc->m_fatal_errors = false;
       /* To prevent -fmax-errors= triggering.  */
       --werrorcount;
     }
@@ -789,12 +789,12 @@ gfc_warning (int opt, const char *gmsgid, va_list ap)
   diagnostic_set_info (&diagnostic, gmsgid, &argp, &rich_loc,
 		       DK_WARNING);
   diagnostic.option_index = opt;
-  bool ret = diagnostic_report_diagnostic (global_dc, &diagnostic);
+  bool ret = global_dc->report_diagnostic (&diagnostic);
 
   if (buffered_p)
     {
       pp->buffer = tmp_buffer;
-      global_dc->fatal_errors = fatal_errors;
+      global_dc->m_fatal_errors = fatal_errors;
 
       warningcount_buffered = 0;
       werrorcount_buffered = 0;
@@ -983,7 +983,7 @@ gfc_diagnostic_build_kind_prefix (diagnostic_context *context,
   gcc_assert (diagnostic->kind < DK_LAST_DIAGNOSTIC_KIND);
   const char *text = _(diagnostic_kind_text[diagnostic->kind]);
   const char *text_cs = "", *text_ce = "";
-  pretty_printer *pp = context->printer;
+  pretty_printer *pp = context->m_printer;
 
   if (diagnostic_kind_color[diagnostic->kind])
     {
@@ -1000,14 +1000,14 @@ static char *
 gfc_diagnostic_build_locus_prefix (diagnostic_context *context,
 				   expanded_location s)
 {
-  pretty_printer *pp = context->printer;
+  pretty_printer *pp = context->m_printer;
   const char *locus_cs = colorize_start (pp_show_color (pp), "locus");
   const char *locus_ce = colorize_stop (pp_show_color (pp));
   return (s.file == NULL
 	  ? build_message_string ("%s%s:%s", locus_cs, progname, locus_ce )
 	  : !strcmp (s.file, N_("<built-in>"))
 	  ? build_message_string ("%s%s:%s", locus_cs, s.file, locus_ce)
-	  : context->show_column
+	  : context->m_show_column
 	  ? build_message_string ("%s%s:%d:%d:%s", locus_cs, s.file, s.line,
 				  s.column, locus_ce)
 	  : build_message_string ("%s%s:%d:%s", locus_cs, s.file, s.line, locus_ce));
@@ -1019,7 +1019,7 @@ static char *
 gfc_diagnostic_build_locus_prefix (diagnostic_context *context,
 				   expanded_location s, expanded_location s2)
 {
-  pretty_printer *pp = context->printer;
+  pretty_printer *pp = context->m_printer;
   const char *locus_cs = colorize_start (pp_show_color (pp), "locus");
   const char *locus_ce = colorize_stop (pp_show_color (pp));
 
@@ -1027,7 +1027,7 @@ gfc_diagnostic_build_locus_prefix (diagnostic_context *context,
 	  ? build_message_string ("%s%s:%s", locus_cs, progname, locus_ce )
 	  : !strcmp (s.file, N_("<built-in>"))
 	  ? build_message_string ("%s%s:%s", locus_cs, s.file, locus_ce)
-	  : context->show_column
+	  : context->m_show_column
 	  ? build_message_string ("%s%s:%d:%d-%d:%s", locus_cs, s.file, s.line,
 				  MIN (s.column, s2.column),
 				  MAX (s.column, s2.column), locus_ce)
@@ -1073,11 +1073,11 @@ gfc_diagnostic_starter (diagnostic_context *context,
     ? gfc_diagnostic_build_locus_prefix (context, s1)
     : gfc_diagnostic_build_locus_prefix (context, s1, s2);
 
-  if (!context->show_caret
+  if (!context->m_show_caret
       || diagnostic_location (diagnostic, 0) <= BUILTINS_LOCATION
-      || diagnostic_location (diagnostic, 0) == context->last_location)
+      || diagnostic_location (diagnostic, 0) == context->m_last_location)
     {
-      pp_set_prefix (context->printer,
+      pp_set_prefix (context->m_printer,
 		     concat (locus_prefix, " ", kind_prefix, NULL));
       free (locus_prefix);
 
@@ -1091,24 +1091,24 @@ gfc_diagnostic_starter (diagnostic_context *context,
 	  [locus]:[prefix]: (1)
 
 	 and we flush with a new line before setting the new prefix.  */
-      pp_string (context->printer, "(1)");
-      pp_newline (context->printer);
+      pp_string (context->m_printer, "(1)");
+      pp_newline (context->m_printer);
       locus_prefix = gfc_diagnostic_build_locus_prefix (context, s2);
-      pp_set_prefix (context->printer,
+      pp_set_prefix (context->m_printer,
 		     concat (locus_prefix, " ", kind_prefix, NULL));
       free (kind_prefix);
       free (locus_prefix);
     }
   else
     {
-      pp_verbatim (context->printer, "%s", locus_prefix);
+      pp_verbatim (context->m_printer, "%s", locus_prefix);
       free (locus_prefix);
       /* Fortran uses an empty line between locus and caret line.  */
-      pp_newline (context->printer);
+      pp_newline (context->m_printer);
       diagnostic_show_locus (context, diagnostic->richloc, diagnostic->kind);
       /* If the caret line was shown, the prefix does not contain the
 	 locus.  */
-      pp_set_prefix (context->printer, kind_prefix);
+      pp_set_prefix (context->m_printer, kind_prefix);
     }
 }
 
@@ -1118,11 +1118,11 @@ gfc_diagnostic_start_span (diagnostic_context *context,
 {
   char *locus_prefix;
   locus_prefix = gfc_diagnostic_build_locus_prefix (context, exploc);
-  pp_verbatim (context->printer, "%s", locus_prefix);
+  pp_verbatim (context->m_printer, "%s", locus_prefix);
   free (locus_prefix);
-  pp_newline (context->printer);
+  pp_newline (context->m_printer);
   /* Fortran uses an empty line between locus and caret line.  */
-  pp_newline (context->printer);
+  pp_newline (context->m_printer);
 }
 
 
@@ -1130,8 +1130,8 @@ static void
 gfc_diagnostic_finalizer (diagnostic_context *context,
 			  diagnostic_info *diagnostic ATTRIBUTE_UNUSED)
 {
-  pp_destroy_prefix (context->printer);
-  pp_newline_and_flush (context->printer);
+  pp_destroy_prefix (context->m_printer);
+  pp_newline_and_flush (context->m_printer);
 }
 
 /* Immediate warning (i.e. do not buffer the warning) with an explicit
@@ -1148,7 +1148,7 @@ gfc_warning_now_at (location_t loc, int opt, const char *gmsgid, ...)
   va_start (argp, gmsgid);
   diagnostic_set_info (&diagnostic, gmsgid, &argp, &rich_loc, DK_WARNING);
   diagnostic.option_index = opt;
-  ret = diagnostic_report_diagnostic (global_dc, &diagnostic);
+  ret = global_dc->report_diagnostic (&diagnostic);
   va_end (argp);
   return ret;
 }
@@ -1167,7 +1167,7 @@ gfc_warning_now (int opt, const char *gmsgid, ...)
   diagnostic_set_info (&diagnostic, gmsgid, &argp, &rich_loc,
 		       DK_WARNING);
   diagnostic.option_index = opt;
-  ret = diagnostic_report_diagnostic (global_dc, &diagnostic);
+  ret = global_dc->report_diagnostic (&diagnostic);
   va_end (argp);
   return ret;
 }
@@ -1186,7 +1186,7 @@ gfc_warning_internal (int opt, const char *gmsgid, ...)
   diagnostic_set_info (&diagnostic, gmsgid, &argp, &rich_loc,
 		       DK_WARNING);
   diagnostic.option_index = opt;
-  ret = diagnostic_report_diagnostic (global_dc, &diagnostic);
+  ret = global_dc->report_diagnostic (&diagnostic);
   va_end (argp);
   return ret;
 }
@@ -1204,7 +1204,7 @@ gfc_error_now (const char *gmsgid, ...)
 
   va_start (argp, gmsgid);
   diagnostic_set_info (&diagnostic, gmsgid, &argp, &rich_loc, DK_ERROR);
-  diagnostic_report_diagnostic (global_dc, &diagnostic);
+  global_dc->report_diagnostic (&diagnostic);
   va_end (argp);
 }
 
@@ -1220,7 +1220,7 @@ gfc_fatal_error (const char *gmsgid, ...)
 
   va_start (argp, gmsgid);
   diagnostic_set_info (&diagnostic, gmsgid, &argp, &rich_loc, DK_FATAL);
-  diagnostic_report_diagnostic (global_dc, &diagnostic);
+  global_dc->report_diagnostic (&diagnostic);
   va_end (argp);
 
   gcc_unreachable ();
@@ -1245,7 +1245,7 @@ gfc_warning_check (void)
 {
   if (! gfc_output_buffer_empty_p (pp_warning_buffer))
     {
-      pretty_printer *pp = global_dc->printer;
+      pretty_printer *pp = global_dc->m_printer;
       output_buffer *tmp_buffer = pp->buffer;
       pp->buffer = pp_warning_buffer;
       pp_really_flush (pp);
@@ -1253,8 +1253,7 @@ gfc_warning_check (void)
       werrorcount += werrorcount_buffered;
       gcc_assert (warningcount_buffered + werrorcount_buffered == 1);
       pp->buffer = tmp_buffer;
-      diagnostic_action_after_output (global_dc,
-				      warningcount_buffered
+      global_dc->action_after_output (warningcount_buffered
 				      ? DK_WARNING : DK_ERROR);
       diagnostic_check_max_errors (global_dc, true);
     }
@@ -1285,8 +1284,8 @@ gfc_error_opt (int opt, const char *gmsgid, va_list ap)
 
   diagnostic_info diagnostic;
   rich_location richloc (line_table, UNKNOWN_LOCATION);
-  bool fatal_errors = global_dc->fatal_errors;
-  pretty_printer *pp = global_dc->printer;
+  bool fatal_errors = global_dc->m_fatal_errors;
+  pretty_printer *pp = global_dc->m_printer;
   output_buffer *tmp_buffer = pp->buffer;
 
   gfc_clear_pp_buffer (pp_error_buffer);
@@ -1295,23 +1294,23 @@ gfc_error_opt (int opt, const char *gmsgid, va_list ap)
     {
       /* To prevent -dH from triggering an abort on a buffered error,
 	 save abort_on_error and restore it below.  */
-      saved_abort_on_error = global_dc->abort_on_error;
-      global_dc->abort_on_error = false;
+      saved_abort_on_error = global_dc->m_abort_on_error;
+      global_dc->m_abort_on_error = false;
       pp->buffer = pp_error_buffer;
-      global_dc->fatal_errors = false;
+      global_dc->m_fatal_errors = false;
       /* To prevent -fmax-errors= triggering, we decrease it before
 	 report_diagnostic increases it.  */
       --errorcount;
     }
 
   diagnostic_set_info (&diagnostic, gmsgid, &argp, &richloc, DK_ERROR);
-  diagnostic_report_diagnostic (global_dc, &diagnostic);
+  global_dc->report_diagnostic (&diagnostic);
 
   if (buffered_p)
     {
       pp->buffer = tmp_buffer;
-      global_dc->fatal_errors = fatal_errors;
-      global_dc->abort_on_error = saved_abort_on_error;
+      global_dc->m_fatal_errors = fatal_errors;
+      global_dc->m_abort_on_error = saved_abort_on_error;
 
     }
 
@@ -1355,7 +1354,7 @@ gfc_internal_error (const char *gmsgid, ...)
 
   va_start (argp, gmsgid);
   diagnostic_set_info (&diagnostic, gmsgid, &argp, &rich_loc, DK_ICE);
-  diagnostic_report_diagnostic (global_dc, &diagnostic);
+  global_dc->report_diagnostic (&diagnostic);
   va_end (argp);
 
   gcc_unreachable ();
@@ -1393,14 +1392,14 @@ gfc_error_check (void)
       || ! gfc_output_buffer_empty_p (pp_error_buffer))
     {
       error_buffer.flag = false;
-      pretty_printer *pp = global_dc->printer;
+      pretty_printer *pp = global_dc->m_printer;
       output_buffer *tmp_buffer = pp->buffer;
       pp->buffer = pp_error_buffer;
       pp_really_flush (pp);
       ++errorcount;
       gcc_assert (gfc_output_buffer_empty_p (pp_error_buffer));
       pp->buffer = tmp_buffer;
-      diagnostic_action_after_output (global_dc, DK_ERROR);
+      global_dc->action_after_output (DK_ERROR);
       diagnostic_check_max_errors (global_dc, true);
       return true;
     }
@@ -1485,11 +1484,11 @@ void
 gfc_diagnostics_init (void)
 {
   diagnostic_starter (global_dc) = gfc_diagnostic_starter;
-  global_dc->start_span = gfc_diagnostic_start_span;
+  global_dc->m_start_span = gfc_diagnostic_start_span;
   diagnostic_finalizer (global_dc) = gfc_diagnostic_finalizer;
   diagnostic_format_decoder (global_dc) = gfc_format_decoder;
-  global_dc->caret_chars[0] = '1';
-  global_dc->caret_chars[1] = '2';
+  global_dc->set_caret_char (0, '1');
+  global_dc->set_caret_char (1, '2');
   pp_warning_buffer = new (XNEW (output_buffer)) output_buffer ();
   pp_warning_buffer->flush_p = false;
   /* pp_error_buffer is statically allocated.  This simplifies memory
@@ -1506,6 +1505,6 @@ gfc_diagnostics_finish (void)
      defaults.  */
   diagnostic_starter (global_dc) = gfc_diagnostic_starter;
   diagnostic_finalizer (global_dc) = gfc_diagnostic_finalizer;
-  global_dc->caret_chars[0] = '^';
-  global_dc->caret_chars[1] = '^';
+  global_dc->set_caret_char (0, '^');
+  global_dc->set_caret_char (1, '^');
 }
diff --git a/gcc/fortran/options.c b/gcc/fortran/options.c
index 1405f1c..82073b1 100644
--- a/gcc/fortran/options.c
+++ b/gcc/fortran/options.c
@@ -334,9 +334,9 @@ gfc_post_options (const char **pfilename)
       /* Enable -Werror=line-truncation when -Werror and -Wno-error have
 	 not been set.  */
       if (warn_line_truncation && !global_options_set.x_warnings_are_errors
-	  && (global_dc->classify_diagnostic[OPT_Wline_truncation] ==
+	  && (global_dc->m_classify_diagnostic[OPT_Wline_truncation] ==
 	      DK_UNSPECIFIED))
-	diagnostic_classify_diagnostic (global_dc, OPT_Wline_truncation,
+	global_dc->classify_diagnostic (OPT_Wline_truncation,
 					DK_ERROR, UNKNOWN_LOCATION);
     }
   else
diff --git a/gcc/gcc.c b/gcc/gcc.c
index 6db0135..0a76dd3 100644
--- a/gcc/gcc.c
+++ b/gcc/gcc.c
@@ -3914,7 +3914,7 @@ driver_handle_option (struct gcc_options *opts,
       return true;
 
     case OPT_fdiagnostics_color_:
-      diagnostic_color_init (dc, value);
+      dc->color_init (value);
       break;
 
     case OPT_Wa_:
@@ -7369,8 +7369,8 @@ driver::global_initializations ()
 
   gcc_init_libintl ();
 
-  diagnostic_initialize (global_dc, 0);
-  diagnostic_color_init (global_dc);
+  global_dc->initialize (0);
+  global_dc->color_init ();
 
 #ifdef GCC_DRIVER_HOST_INITIALIZATION
   /* Perform host dependent initialization when needed.  */
@@ -10045,7 +10045,7 @@ driver::finalize ()
 {
   env.restore ();
   params_c_finalize ();
-  diagnostic_finish (global_dc);
+  global_dc->finish ();
 
   is_cpp_driver = 0;
   at_file_supplied = 0;
diff --git a/gcc/gcov-dump.c b/gcc/gcov-dump.c
index ba432db..c006444 100644
--- a/gcc/gcov-dump.c
+++ b/gcc/gcov-dump.c
@@ -99,7 +99,7 @@ main (int argc ATTRIBUTE_UNUSED, char **argv)
 
   gcc_init_libintl ();
 
-  diagnostic_initialize (global_dc, 0);
+  global_dc->initialize (0);
 
   while ((opt = getopt_long (argc, argv, "hlpvw", options, NULL)) != -1)
     {
diff --git a/gcc/gcov-tool.c b/gcc/gcov-tool.c
index 15fd710..40d465e 100644
--- a/gcc/gcov-tool.c
+++ b/gcc/gcov-tool.c
@@ -590,7 +590,7 @@ main (int argc, char **argv)
 
   gcc_init_libintl ();
 
-  diagnostic_initialize (global_dc, 0);
+  global_dc->initialize (0);
 
   /* Handle response files.  */
   expandargv (&argc, &argv);
diff --git a/gcc/gcov.c b/gcc/gcov.c
index 37f431c..84efc90 100644
--- a/gcc/gcov.c
+++ b/gcc/gcov.c
@@ -768,7 +768,7 @@ main (int argc, char **argv)
 
   gcc_init_libintl ();
 
-  diagnostic_initialize (global_dc, 0);
+  global_dc->initialize (0);
 
   /* Handle response files.  */
   expandargv (&argc, &argv);
